# ncert_learn

**ncert_learn** is a Python module designed for NCERT Class 12 Computer Science students. It provides a wide range of utility functions, covering Python programming, MySQL database interactions, mathematical operations, data structures, and various other essential topics to support learning and development.

## Key Features

- **Mathematical Functions**: 
  - Check for prime numbers, Armstrong numbers, strong numbers, Niven numbers, and more.
  - Functions for calculating Fibonacci numbers, even/odd checks, and other numerical operations.

- **Data Structures**: 
  - Stack implementations using lists and dictionaries, with functions to manipulate and display the stack.

- **Geometric Calculations**: 
  - Functions to calculate areas of common geometric shapes such as circles, rectangles, squares, polygons, and triangles.

- **Number Conversions**: 
  - Functions to convert integers to binary, octal, hexadecimal formats, and conversions from binary back to integer.

- **MySQL Operations**: 
  - Connect to MySQL, create and show databases, manage tables, and execute SQL queries directly from Python.

- **Sorting Algorithms**: 
  - Includes basic sorting algorithms like Bubble Sort and Insertion Sort.

- **File Handling**: 
  - Functions to check if a file is a text file, read from or write to text files, and manage file contents.

- **Operating System Utilities**: 
  - Retrieve information about the current operating system, Python interpreter, CPU count, directory listings, and network connectivity.

- **Package Management**: 
  - Functions to install Python libraries, including batch installation from a list.

- **Time Functions**: 
  - Access the current time, process time, monotonic time, and thread time.

- **Support and Documentation**: 
  - Links to support email, feedback email, bug tracker, GitHub repository, and documentation.

## New Features in Version 2.6.0

- **Expanded Mathematical Functions**: More advanced checks for prime, Armstrong, and Niven numbers.
- **Enhanced File Handling**: Improved text file management, including copying contents from one file to another.
- **System Utilities**: Added functions to fetch current Python interpreter path, processor details, and check network connectivity.
- **MySQL Updates**: Improved MySQL database and table management functions.
- **Time Management**: Added time-based functions like process time and thread time.
  
## Bug Fixes
- **Error Handling Improvements**: Enhanced error handling for file operations and MySQL interactions.

## Changelog
See [CHANGELOG.md](CHANGELOG.md) for details on version changes.

## Installation

To install `ncert_learn`, simply use `pip`:

```bash
pip install ncert_learn

